#if !defined(__TCEDIALG_H)              // Sentry.
#define __TCEDIALG_H

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\dialog.H>
#include "ctrlenab.h" // TControlEnabler header

#include <classlib\listimp.h>

// TCEDialog implementation.  This is the dialog class for use with TControlEnablers.
// To use a TControlEnabler, you derive your own enabler from it and override the
// condition() member function to return true in cases where the control that you
// are defining it for should be enabled.  Then you use TCEDialog::InstallEnabler
// to install it.  Your enabler object should be created with new, and there is no
// need to delete it.

typedef TIListImp<TControlEnabler> TEnablerList;
typedef TIListIteratorImp<TControlEnabler> TEnablerIterator;

//{{TDialog = TCEDialog}}
class TCEDialog : public TDialog {
public:
    TCEDialog (TWindow* parent, TResId resId, TModule* module = 0);
    virtual ~TCEDialog ();

	void InstallEnabler(TControlEnabler* toInstall);

private:
	void DoNotify();
	TEnablerList* eList;


//{{TCEDialogVIRTUAL_BEGIN}}
public:
	virtual BOOL DialogFunction (UINT message, WPARAM wParam, LPARAM lParam);
//{{TCEDialogVIRTUAL_END}}
};    //{{TCEDialog}}


#endif                                      // __tcedialg_h sentry.

